
/** 
 * Finanz version C.
 * Multi threaded application generates transactions using
 * objects from KontoC and displays results.
 * Uses Konto interface, non negative Konto and java.util.concurrent.
 * @author Heinz Kredel. 
 */ 

public class FinanzC {

    public static void main(String[] args) {

      for (int i=0; i < 10; i++) {
	Konto a = new KontoC(-10.0);
        Konto b = new KontoC(300.0);

        Thread t1 = new Ueberweisung(a,b,10.0);
        Thread t2 = new Ueberweisung(a,b,10.0);
        Thread t3 = new Ueberweisung(a,b,10.0);
        Thread t4 = new Ueberweisung(b,a,50.0);

        t1.start(); t2.start(); t3.start(); t4.start();

        System.out.println("Stand a = " + a.zeigeGeld() +
                           " Stand b = " + b.zeigeGeld() );

        try {
            t1.join(); t2.join(); t3.join(); t4.join();
	} catch(InterruptedException e ) { }

        System.out.println("Endstand a = " + a.zeigeGeld() +
                           " Endstand b = " + b.zeigeGeld() );
      }
    }

}
