
/**
 * Konto version A.
 * Uses synchronized methods to display, add and remove money from the account.
 * @author Heinz Kredel.
 */
public class KontoA implements Konto {

    private double stand; // Konto Stand

    public KontoA() { stand = 0.0; } //sets "kontostand" to a desired value

    public KontoA(double a) { stand = a; }
    

/**
 * Displays account balance.
 * @return stand.
 */
    public synchronized double zeigeGeld() { return stand; }


/**
 * @param b adds desired value to current account.
 * @return s after booking (a call to "WorkA" is done,
 * where current thread sleeps for a random time).
 * current account balance is given back.
 */
    public synchronized double putGeld(double b) { // stand += b
	double s = stand + b;
        WorkA.schaffen(100);
        stand = s;
        return s;   
    }
    

/**
 * @param b draws desired value from the account.
 * @return s gives back current account balance.
 */
    public synchronized double getGeld(double b) { // stand -= b
	double s = stand - b;
        WorkA.schaffen(100);
        stand = s;
        return s;   
    }

}


/**
 * Sending current thread to sleep for a random time.
 */
class WorkA {

/**
 * @param max defines range of numbers for Math.random().
 */
	public static void schaffen(int max) {
	try {
            Thread.currentThread().sleep( (int)(max*Math.random()) );
        } catch (InterruptedException e) {
              System.out.println("Dies sollte nicht passieren "+e);
	}
    }
}
