
import java.io.*;

 /** 
  * Konto version S.
  * This class is serializable.
  * Uses synchronized methods to display, add and remove money 
  * from the account.
  * @author Heinz Kredel.
  */
public class KontoS implements Konto, Serializable {

    private double stand;

    public KontoS() { stand = 0.0; }

    public KontoS(double a) { stand = a; }


/**
 * @return stand.
 */
    public synchronized double zeigeGeld() { 
	Work.schaffen(20);
        return stand;
    }


/**
 * @param b amount to put on account.
 * @return s current account balance.
 */
    public synchronized double putGeld(double b) { 
        double s = stand + b;
 	Work.schaffen(20);
        stand = s;
        return s;
    }


/**
 * @param b A Double, amount to get from account.
 * @return s A Double, returns actual balance.
 */
    public synchronized double getGeld(double b) { 
       double s = stand - b;
 	Work.schaffen(20);
        stand = s;
        return s;
    }

}
