

import java.util.Random;

/**
 * TSP solver 
 */

public class TSP {

    public static void main(String[] args) {

        int n = 7;
        int im = Integer.MAX_VALUE;
        int t = 4;

        try { 
            n = Integer.parseInt(args[0]); 
        } catch (Exception e) { }
        try { 
            t = Integer.parseInt(args[1]); 
        } catch (Exception e) { }
        try { 
            im = Integer.parseInt(args[2]); 
        } catch (Exception e) { }

        Point[] points = new Point[n];
        double m = 100;
        Random r = new Random();
        for ( int i = 0; i < n; i++ ) {
            points[i] = Point.random(i,r,m);
        }

        long tm;

        TSPInf sb  = new SeqByteTSP(points);
        TSPInf plb = new ParByteLocalTSP(points,t);
        TSPInf ssb = new SeqByteStackTSP(points);
        TSPInf d   = new DistTSP(points,t);

        Path best = null;

        // byte[] versions
	/*
        tm = System.currentTimeMillis();
	best = sb.getBest(im);
        tm = System.currentTimeMillis() - tm; 
        System.out.println("\nbest byte seq = " + best + "");
        System.out.println(tm + "ms\n");
	*/
        tm = System.currentTimeMillis();
        best = plb.getBest(im);
        tm = System.currentTimeMillis() - tm; 
        System.out.println("\nbest byte par local rec = " + best + "");
        System.out.println(tm + "ms\n");
	
        tm = System.currentTimeMillis();
        best = ssb.getBest(im);
        tm = System.currentTimeMillis() - tm; 
        System.out.println("\nbest byte seq stack rec = " + best + "");
        System.out.println(tm + "ms\n");

        tm = System.currentTimeMillis();
        best = d.getBest(im);
        tm = System.currentTimeMillis() - tm; 
        System.out.println("\nbest byte dist = " + best + "");
        System.out.println(tm + "ms\n");

    }

}
