
package gui;

import java.awt.event.KeyListener;
import java.awt.event.WindowListener;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.event.ChangeListener;
import javax.swing.Timer;
import javax.swing.JFrame;


/**
 * Main class to handle the TSPs and the GUI.
 * @author Heinz Kredel.
 */
public class TSPgui {

/**
 * @param args unused.
 */
    public static void main(String[] args) {

        final TSPguiModel model = new TSPguiModel();
        KeyListener keyControl = new TSPguiKeyControl(model);
        WindowListener windowControl = new TSPguiWindowControl(model);
        ActionListener actionControl = new TSPguiActionControl(model);
        ChangeListener changeControl = new TSPguiChangeControl(model);
        //JFrame.setDefaultLookAndFeelDecorated(true);
        JFrame main = new TSPguiMain(model,
                                     keyControl,
                                     windowControl,
                                     actionControl,
                                     changeControl);
        ActionListener wecker = new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                        model.doUpdate();
                }
        };
        Timer repaint = new Timer(250, wecker);
        repaint.start();
        
        model.waitDone(); 
        main.setVisible(false);
        repaint.stop();
        main.dispose();
        System.exit(0);
    }

}
